﻿@inject HttpClient HttpClient

<MudGrid>
    <MudItem xs="12" sm="6" md="4">
        <MudSelect @bind-Value="SelectedRegionId"
                   Label="地方" Variant="Variant.Filled">
            <MudSelectItem Value="@(0)">@(" ")</MudSelectItem>
            @foreach (var region in regions)
            {
                <MudSelectItem T="int" Value="@(region.RegionId)">@region.RegionName</MudSelectItem>
            }
        </MudSelect>
    </MudItem>
    <MudItem xs="12" sm="6" md="4">
        <MudSelect @bind-Value="SelectedPrefectureId" Label="都道府県" Variant="Variant.Filled">
            <MudSelectItem Value="@(0)">@(" ")</MudSelectItem>
            @foreach (var prefecture in prefectures)
            {
                <MudSelectItem Value="@(prefecture.PrefectureId)">@prefecture.PrefectureName</MudSelectItem>
            }
        </MudSelect>
    </MudItem>
</MudGrid>

@code {
    private int _selectedRegionId { get; set; }

    [Parameter]
    public int SelectedRegionId
    {
        get { return _selectedRegionId; }
        set
        {
            if (_selectedRegionId != value)
            {
                _selectedRegionId = value;
                if (SelectedRegionIdChanged.HasDelegate)
                {
                    SelectedRegionIdChanged.InvokeAsync(value);
                }
                prefectures = prefectures.Where(p => SelectedRegionId == 0 || p.RegionId == SelectedRegionId);
                if (prefectures.Where(p => p.PrefectureId == SelectedPrefectureId).Any())
                {
                    return;
                }
                SelectedPrefectureId = 0;
            }
        }

    }

    private int _selectedPrefectureId { get; set; }

    [Parameter]
    public int SelectedPrefectureId
    {
        get { return _selectedPrefectureId; }
        set
        {
            if (_selectedPrefectureId != value)
            {
                _selectedPrefectureId = value;
                if (SelectedPrefectureIdChanged.HasDelegate)
                {
                    SelectedPrefectureIdChanged.InvokeAsync(value);
                }
            }
        }
    }

    [Parameter]
    public EventCallback<int> SelectedRegionIdChanged { get; set; }
    [Parameter]
    public EventCallback<int> SelectedPrefectureIdChanged { get; set; }

    private IEnumerable<RegionEntity> regions = new List<RegionEntity>();
    private IEnumerable<PrefectureEntity> prefectures = new List<PrefectureEntity>();

    protected async override Task OnInitializedAsync()
    {
        regions = await HttpClient.GetFromJsonAsync<List<RegionEntity>>("api/Regions");
        prefectures = await HttpClient.GetFromJsonAsync<List<PrefectureEntity>>("api/Prefectures");
        if (SelectedPrefectureId != 0 && SelectedRegionId == 0)
        {
            SelectedRegionId = prefectures.Where(p => p.PrefectureId == SelectedPrefectureId).FirstOrDefault().RegionId;
        }
    }

}